<?php
/**
 * Various useful snippets for WordPress.
 * Uncomment as needed.
 *
 * This file should be included from the child theme's functions.php
 * using `include_once get_stylesheet_directory() . '/snippets.php';`.
 */
defined('ABSPATH') || exit;


/**
 * Uncomment to use a custom text domain with child theme.
 *
 * Important: change `Text Domain: ska-theme` to `Text Domain: ska-theme-child` in /wp-content/themes/ska-theme-child/style.css file.
 * (instead of "ska-theme-child" you can also use a custom domain like "example")
 *
 * Once enabled, you can use `__('String', 'ska-theme-child')` in your custom code
 * and translate them using Loco Translate or similar plugin.
 *
 * @see https://wordpress.org/plugins/loco-translate/
 */
// add_action('after_setup_theme', function() {
// 	load_child_theme_textdomain('ska-theme-child');
// });


/**
 * Uncomment to disable auto-update email notifications.
 */
// add_filter('auto_core_update_send_email', '__return_false');
// add_filter('auto_plugin_update_send_email', '__return_false');
// add_filter('auto_theme_update_send_email', '__return_false');


/**
 * Uncomment to not notify the blog admin of a user changing password.
 */
// if(!function_exists('wp_password_change_notification')) {
// 	function wp_password_change_notification($user) {}
// }


/**
 * Uncomment to disable the
 * 	`Please verify that the administration email for this website is still correct.`
 * check when logging in.
 *
 * @see https://developer.wordpress.org/reference/hooks/admin_email_check_interval/
 */
// add_filter('admin_email_check_interval', '__return_zero'); // Default: 6 * MONTH_IN_SECONDS


/**
 * Uncomment to increase authentication cookie duration.
 * This determines how long you stay logged in to wp-admin.
 *
 * @see https://developer.wordpress.org/reference/hooks/auth_cookie_expiration/
 */
// add_filter('auth_cookie_expiration', function($duration, $user_id, $remember) {
// 	if($remember) {
// 		$duration = 64 * DAY_IN_SECONDS; // Default: 14 days
// 	}
// 	return $duration;
// }, 10, 3);


/**
 * Uncomment to disable XML-RPC on your site.
 * XML-RPC is typically used in various brute-force attacks.
 *
 * @see https://developer.wordpress.org/reference/hooks/xmlrpc_enabled/
 */
// add_filter('xmlrpc_enabled', '__return_false');


/**
 * Uncomment to disable notices from plugins that respect this constant.
 */
// defined('DISABLE_NAG_NOTICES') || define('DISABLE_NAG_NOTICES', true);


/**
 * Uncomment to disable Contact Form 7 welcome notice that re-appears after updates.
 */
// add_filter('get_user_metadata', function($value, $object_id, $meta_key, $single, $meta_type) {
// 	return $meta_key === 'wpcf7_hide_welcome_panel_on' && function_exists('wpcf7_version') ? wpcf7_version('only_major=1') : $value;
// }, 10, 5);


/**
 * Uncomment to disable Contact Form 7 validation that re-appears from time to time.
 */
// add_filter('wpcf7_validate_configuration', function($validate) {
// 	return isset($_POST['wpcf7-save']) ? $validate : false;
// });


/**
 * Uncomment to disable WooCommerce marketplace suggestions.
 *
 * This also has an option at `WooCommerce -> Settings -> Advanced -> WooCommerce.com -> Show Suggestions`.
 */
// add_filter('woocommerce_allow_marketplace_suggestions', '__return_false');


/**
 * Uncomment to disable WooCommerce Blocks patterns.
 */
// add_action('init', function() {
// 	if(!class_exists('Automattic\\WooCommerce\\Blocks\\BlockPatterns')) {
// 		return;
// 	}
// 	$block_patterns = Automattic\WooCommerce\Blocks\Package::container()->get(Automattic\WooCommerce\Blocks\BlockPatterns::class);
// 	remove_action('init', [$block_patterns, 'register_block_patterns']);
// }, 9);


/**
 * Uncomment to display featured images in post list.
 */
// add_action('admin_head', function() {
// 	echo '<style>' .
// 		':root { --ska-post-list-featured-image-width: 40px; } ' .
// 		'th#ska-post-list-featured-image { width: var(--ska-post-list-featured-image-width); } ' .
// 		'.ska-post-list-thumb { width: var(--ska-post-list-featured-image-width); aspect-ratio: 1; background-color: #f1f1f1; line-height: 0; } ' .
// 		'.ska-post-list-thumb img { width: 100%; height: 100%; object-fit: cover; border-radius: 1px; }' .
// 	'</style>';
// });
// add_filter('manage_posts_columns', function($columns) {
// 	if(
// 		!isset($columns['cb'])
// 		|| isset($columns['ska-post-list-thumb'])
// 		|| !in_array(get_post_type(), [
// 			'post',
// 			'ska_testimonial',
// 			'ska_portfolio',
// 		])
// 	) {
// 		return $columns;
// 	}
// 	return array_merge([
// 		'cb' => $columns['cb'],
// 		'ska-post-list-featured-image' => '',
// 	], array_slice($columns, 1));
// });
// add_filter('manage_posts_custom_column', function($column_name, $post_id) {
// 	if($column_name === 'ska-post-list-featured-image') {
// 		printf('<div class="ska-post-list-thumb">%s</div>', get_the_post_thumbnail($post_id, 'thumbnail'));
// 	}
// 	return $column_name;
// }, 10, 2);


/**
 * Uncomment to enable a debug function.
 */
// if(!function_exists('pre_dump')):
// 	/**
// 	 * PHP `var_dump()` alternative that wraps the output in `<pre>` and adds styling.
// 	 *
// 	 * @param any $var Variable to output.
// 	 * @param boolean $esc_html Set to `true` to escape HTML to prevent rendering it.
// 	 * @param boolean $delay Set to `true` to output the dump at a WordPress hook.
// 	 */
// 	function pre_dump($var, $esc_html = false, $delay = false) {
// 		if(
// 			isset($_GET['nodump'])
// 			|| (function_exists('wp_doing_ajax') && wp_doing_ajax())
// 		) {
// 			return;
// 		}
// 		$styles = [
// 			'color' => 'black',
// 			'background' => 'snow',
// 			'margin-top' => '16px',
// 			'max-height' => '420px',
// 			'overflow-y' => 'scroll',
// 			'text-align' => 'left',
// 			'padding' => '4px',
// 			'border' => '1px solid #c3c4c7',
// 			'border-radius' => '4px',
// 			'line-height' => '1.3',
// 		];
// 		if(function_exists('is_admin') && is_admin()) {
// 			/** Indent the output in WP-admin to prevent it being hidden behind sidebar. */
// 			$styles['margin-left'] = '180px';
// 			$styles['margin-right'] = '20px';
// 		}
// 		$style = '';
// 		foreach($styles as $key => $val) {
// 			$style .= $key . ': ' . $val . '; ';
// 		}
// 		ob_start();
// 		echo '<pre style="' . $style . '">'; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped
// 		var_dump($esc_html && function_exists('esc_html') ? esc_html($var) : $var);
// 		echo '</pre>';
// 		$dump = ob_get_clean();
// 		$render = function() use ($dump) {
// 			echo $dump; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped
// 		};
// 		if($delay) {
// 			if(function_exists('is_admin') && is_admin()) {
// 				$hook = function_exists('did_action') && did_action('admin_notices') ? 'admin_footer' : 'admin_notices';
// 				add_action($hook, $render, PHP_INT_MAX);
// 			} else {
// 				add_action('wp_footer', $render, PHP_INT_MAX);
// 			}
// 		} else {
// 			$render();
// 		}
// 	}
// endif;
